Attribute VB_Name = "Common"
Option Explicit

' A`^
Public Type BUBBLE
    x       As Integer  ' XW
    y       As Integer  ' YW
    Color   As Long     ' AF
    Visible As Boolean  ' \tO
End Type

Public Type WALL
    x       As Integer  ' XW
    y       As Integer  ' YW
End Type

' pxWAϊ
Public Const PI             As Double = 3.14159 / 180

' Q[萔
Public Const SCROLLSPEED    As Integer = 8  ' XN[x
Public Const PLANEMOVE      As Integer = 12 ' s@ړ
Public Const JUMPVECTOR     As Integer = 24 ' WvxNg
Public Const GRAVITY        As Integer = 4  ' d

' ʐ
Public gintScene            As Integer      ' ݂̉
Public Const scNONE         As Integer = -1 ' 
Public Const scTITLE        As Integer = 0  ' ^Cg
Public Const scSTAGE        As Integer = 1  ' Xe[W
Public Const scTIWNTIWN     As Integer = 2  ' eBEeBE
Public Const scOWATA        As Integer = 3  ' I^

' 
Public gblnKeyUp            As Boolean      ' tO
Public gblnKeyDown          As Boolean      ' tO
Public gblnKeyLeft          As Boolean      ' tO
Public gblnKeyRight         As Boolean      ' tO
Public gblnKeyJump          As Boolean      ' WvtO
Public gblnKeyCancel        As Boolean      ' LZtO

' Q[ŜŎgpϐ
Public glngPosition         As Long         ' Ƃ񂾋
Public gintScore            As Integer      ' XRA

' s@
Public gintPlaneX           As Integer      ' s@̉ʓ̈ʒu
Public gintPlaneY           As Integer      ' s@̉ʓ̈ʒu
Public gintOwataY           As Integer      ' I^̔s@Ƃ̑Έʒu

' A
Public Const BUBBLE_TXT     As String = "bubbles.txt"   ' At@C
Public Const BUBBLERADIUS   As Integer = 24 ' Aa
Public gintBubbles          As Integer      ' Avf
Public gstBubbles(999)      As BUBBLE       ' A

' 
Public Const WALLU_TXT      As String = "wallu.txt"   ' ǃt@C
Public gintWallU            As Integer      ' Ǘvf
Public gstWallU(999)        As WALL         ' 
Public Const WALLL_TXT      As String = "walll.txt"   ' ǃt@C
Public gintWallL            As Integer      ' Ǘvf
Public gstWallL(999)        As WALL         ' 

' ʑJ
Public Sub ChangeScene(ByVal intFromScene As Integer, ByVal intToScene As Integer)
    
    ' ʑJڑȌI
    Select Case intFromScene
        Case scTITLE
            Call SCENE_TITLE_Finalize
            
        Case scSTAGE
            Call SCENE_STAGE_Finalize
        
        Case scTIWNTIWN
            Call SCENE_TIWNTIWN_Finalize

        Case scOWATA
            Call SCENE_OWATA_Finalize

    End Select

    ' ʑJ
    gintScene = intToScene
    
    ' ʑJڎ̏
    Select Case intToScene
        Case scTITLE
            Call SCENE_TITLE_Initialize
            
        Case scSTAGE
            Call SCENE_STAGE_Initialize
        
        Case scTIWNTIWN
            Call SCENE_TIWNTIWN_Initialize

        Case scOWATA
            Call SCENE_OWATA_Initialize

    End Select

End Sub

Public Sub InitBubble()
        
    Dim lngColors(2)    As Long
    
    lngColors(0) = vbYellow
    lngColors(1) = vbRed
    
    Randomize Timer
    
    For gintBubbles = 0 To 490
        gstBubbles(gintBubbles).x = 600 + 60 * gintBubbles
        gstBubbles(gintBubbles).y = 100 + Int(Rnd() * 30) * 10
        gstBubbles(gintBubbles).Color = lngColors(Int(Rnd() * 2))
        gstBubbles(gintBubbles).Visible = True
    Next
    
'    Dim intFileNo       As Integer
'    Dim strLine         As String
'    Dim strValues()     As String
'    Dim lngColors(2)    As Long
'
'    lngColors(0) = vbYellow
'    lngColors(1) = vbRed
'
'    ' t@Cԍ擾
'    intFileNo = FreeFile()
'
'    ' At@CJ
'    Open BUBBLE_TXT For Input As intFileNo
'
'    ' sAƂēǂݍ
'    gintBubbles = 0
'    While Not (EOF(intFileNo)) And gintBubbles < 999    ' 999Œ(-_-;
'        Line Input #intFileNo, strLine
'        strValues = Split(strLine, ",")
'        gstBubbles(gintBubbles).x = CLng(strValues(0))
'        gstBubbles(gintBubbles).y = CLng(strValues(1))
'        gstBubbles(gintBubbles).Color = lngColors(CInt(strValues(2)))
'        gstBubbles(gintBubbles).Visible = True
'        gintBubbles = gintBubbles + 1
'    Wend
'
'    ' t@C
'    Close intFileNo
    
End Sub

Public Sub InitWall()

    For gintWallU = 0 To 250
        gstWallU(gintWallU).x = 120 * gintWallU
        gstWallU(gintWallU).y = 10 + Int(Rnd() * 19) * 10
    Next
    
    For gintWallL = 0 To 100
        gstWallL(gintWallL).x = 300 * gintWallL
        gstWallL(gintWallL).y = 470 - Int(Rnd() * 14) * 10
    Next
    

'    Dim intFileNo       As Integer
'    Dim strLine         As String
'    Dim strValues()     As String
'
'    ' t@Cԍ擾
'    intFileNo = FreeFile()
'
'    ' ǃt@CJ
'    Open WALLU_TXT For Input As intFileNo
'
'    ' sǈʒuƂēǂݍ
'    gintWallU = 0
'    While Not (EOF(intFileNo)) And gintWallU < 999    ' 999Œ(-_-;
'        Line Input #intFileNo, strLine
'        strValues = Split(strLine, ",")
'        gstWallU(gintWallU).x = CLng(strValues(0))
'        gstWallU(gintWallU).y = CLng(strValues(1))
'        gintWallU = gintWallU + 1
'    Wend
'
'    ' t@C
'    Close intFileNo
'
'
'
'    ' t@Cԍ擾
'    intFileNo = FreeFile()
'
'    ' ǃt@CJ
'    Open WALLL_TXT For Input As intFileNo
'
'    ' sǈʒuƂēǂݍ
'    gintWallL = 0
'    While Not (EOF(intFileNo)) And gintWallL < 999    ' 999Œ(-_-;
'        Line Input #intFileNo, strLine
'        strValues = Split(strLine, ",")
'        gstWallL(gintWallL).x = CLng(strValues(0))
'        gstWallL(gintWallL).y = CLng(strValues(1))
'        gintWallL = gintWallL + 1
'    Wend
'
'    ' t@C
'    Close intFileNo
    
'    ' 
'    gstWallU(0).x = 0:     gstWallU(0).y = 30
'    gstWallU(1).x = 500:   gstWallU(1).y = 70
'    gstWallU(2).x = 900:   gstWallU(2).y = 150
'
'    ' 
'    gstWallL(0).x = 0:     gstWallL(0).y = 450
'    gstWallL(1).x = 400:   gstWallL(1).y = 430
'    gstWallL(2).x = 420:   gstWallL(2).y = 330
'    gstWallL(3).x = 440:   gstWallL(3).y = 430
'    gstWallL(4).x = 1200:  gstWallL(4).y = 460
    
End Sub

